#!/bin/bash

function Passwd_character_class(){
	declare -i flag=1
	declare -i flag1=1
	echo "--系统密码包含字符种类设置"
	echo "--系统密码包含字符种类设置" >>/var/log/ctgb_reinforce.log
	standard=$1

	if [ ` test -e /etc/security/pwquality.conf;echo $?` -eq 0 ];then
		if [ `cat -n /etc/security/pwquality.conf |grep -w "minclass" |awk '{print $2, $3, $1}'|egrep "minclass\s+="|grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
			line=`cat -n /etc/security/pwquality.conf |grep -w "minclass"|awk '{print $2,$3, $1}'|egrep "minclass\s+=" |grep -v "^#" |tail -n 1|awk '{print $3}'`
			value=`cat -n /etc/security/pwquality.conf |grep -w "minclass"|awk '{print $2,$3,$4, $1}'|egrep "minclass\s+=" |grep -v "^#" |tail -n 1|awk -F '=' '{print $2}'|awk '{print $1}'`
			setline=$(($line - 1))
				
			if [[ $value -lt $standard ]];then
					flag1=0
			
				if [ $setline -eq 0 ];then
					sed -i "1 d" /etc/security/pwquality.conf
					if [ `sed -i "1 a minclass = $standard" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minclass::minclass = $value" >>/var/log/security_reinforce.txt
					fi

				else
					sed -i "$line d" /etc/security/pwquality.conf
					if [ `sed -i "$setline a minclass = $standard" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minclass::minclass = $value" >>/var/log/security_reinforce.txt
					fi
				fi
			fi
		elif [ `cat  /etc/security/pwquality.conf|awk '{print $1, $2, $3}'|egrep "minclass\s+="|grep "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
			line=`cat -n /etc/security/pwquality.conf |awk '{print $2, $3, $4, $1}'|egrep "minclass\s+=" |grep "^#" |tail -n 1|awk '{print $4}'`
			value1=`cat /etc/security/pwquality.conf |grep -w "minclass"|tail -n 1`
			setline=$(($line - 1))
			flag1=0
			if [ $setline -eq 0 ];then
				sed -i "1 d" /etc/security/pwquality.conf
				if [ `sed -i "1 a minclass = $standard" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
					flag=0
				else
					echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minclass::$value1" >>/var/log/security_reinforce.txt
				fi

			else
				sed -i "$line d" /etc/security/pwquality.conf
				if [ `sed -i "$setline a minclass = $standard" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
					flag=0
				else
					echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minclass::$value1" >>/var/log/security_reinforce.txt
				fi
			fi
			flag1=0
		else
			flag1=0
			if [ `echo "minclass = $standard" >> /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
				flag=0
			else
				echo "ADD_CONFIG::/etc/security/pwquality.conf::minclass::minclass = $standard" >>/var/log/security_reinforce.txt
			fi
				
		fi
	fi

	if [ $flag1 -eq 1 ];then
		echo -e "--,密码最小字符类别设置,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,密码最小字符类别设置,无需加固"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/ctgb_reinforce.log
	elif [ $flag -eq 0 ];then
		echo -e "--,密码最小字符类别设置,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,密码最小字符类别设置,失败"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/ctgb_reinforce.log
	elif [ $flag -eq 1 ];then
		echo -e "--,密码最小字符类别设置,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,密码最小字符类别设置,成功"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/ctgb_reinforce.log
	fi
}


function Passwd_minlen_setting(){
	declare -i flag1=1
	declare -i flag=1
	
	echo "--系统密码最少长度设置"
	echo "--系统密码最少长度设置" >> /var/log/ctgb_reinforce.log
	if [ ` test -e /etc/security/pwquality.conf;echo $?` -eq 0 ];then

		minlen=$1
		if [ -z "$minlen" ];then
			echo -e "--,系统密码长度配置,\033[31m [没有输入长度]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
			flag1=2
			flag=2
		else
			if [ `cat -n /etc/security/pwquality.conf |grep -w "minlen" |awk '{print $2, $3, $1}'|egrep "minlen\s+="|grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
				line=`cat -n /etc/security/pwquality.conf |grep -w "minlen"|awk '{print $2,$3, $1}'|egrep "minlen\s+=" |grep -v "^#" |tail -n 1|awk '{print $3}'`
				value=`cat -n /etc/security/pwquality.conf |grep -w "minlen"|awk '{print $2,$3,$4, $1}'|egrep "minlen\s+=" |grep -v "^#" |tail -n 1|awk -F '=' '{print $2}'|awk '{print $1}'`
				setline=$(($line - 1))
					
				if [[ $value -lt $minlen ]];then
						flag1=0
				
					if [ $setline -eq 0 ];then
						sed -i "1 d" /etc/security/pwquality.conf
						if [ `sed -i "1 a minlen = $minlen" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
							flag=0
						else
							echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minlen::minlen = $value" >>/var/log/security_reinforce.txt
						fi

					else
						sed -i "$line d" /etc/security/pwquality.conf
						if [ `sed -i "$setline a minlen = $minlen" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
							flag=0
						else
							echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minlen::minlen = $value" >>/var/log/security_reinforce.txt
						fi
					fi
				fi
			elif [ `cat  /etc/security/pwquality.conf|awk '{print $1, $2, $3}'|egrep "minlen\s+="|grep "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
				line=`cat -n /etc/security/pwquality.conf |awk '{print $2, $3, $4, $1}'|egrep "minlen\s+=" |grep  "^#" |tail -n 1|awk '{print $4}'`
				value=`cat /etc/security/pwquality.conf |egrep "minlen\s+=" |tail -n 1`
				setline=$(($line - 1))
				flag1=0
				if [ $setline -eq 0 ];then
					sed -i "1 d" /etc/security/pwquality.conf
					if [ `sed -i "1 a minlen = $minlen" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minlen::$value" >>/var/log/security_reinforce.txt
					fi

				else
					sed -i "$line d" /etc/security/pwquality.conf
					if [ `sed -i "$setline a minlen = $minlen" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::minlen::$value" >>/var/log/security_reinforce.txt
					fi
				fi
				flag1=0
			else
				flag1=0
				if [ `echo "minlen = $minlen" >> /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
					flag=0
				else
					echo "ADD_CONFIG::/etc/security/pwquality.conf::minlen::minlen = $minlen" >>/var/log/security_reinforce.txt
				fi
					
			fi
		fi
	fi

	if [ $flag1 -eq 1 ];then
		echo -e "--,系统密码最小长度配置,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,系统密码最小长度配置,无需加固"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >> /var/log/ctgb_reinforce.log
	elif [ $flag -eq 0 ];then
		echo -e "--,系统密码最小长度配置,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,系统密码最小长度配置,失败"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >> /var/log/ctgb_reinforce.log
	elif [ $flag -eq 1 ];then
		echo -e "--,系统密码最小长度配置,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,系统密码最小长度配置,成功"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >> /var/log/ctgb_reinforce.log
	fi
}


function Password_dictcheck_enable(){

	declare -i flag=1
	declare -i flag1=1
	str=""
	echo "--系统密码字典检查配置"

	if [ ` test -e /etc/security/pwquality.conf;echo $?` -eq 0 ];then

		if [ `cat -n /etc/security/pwquality.conf |grep -w "dictcheck" |awk '{print $2, $3, $1}'|egrep "dictcheck\s+="|grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
			line=`cat -n /etc/security/pwquality.conf |grep -w "dictcheck"|awk '{print $2,$3, $1}'|egrep "dictcheck\s+=" |grep -v "^#" |tail -n 1|awk '{print $3}'`
			value=`cat -n /etc/security/pwquality.conf |grep -w "dictcheck"|awk '{print $2,$3,$4, $1}'|egrep "dictcheck\s+=" |grep -v "^#" |tail -n 1|awk -F '=' '{print $2}'|awk '{print $1}'`
			setline=$(($line - 1))
				
			if [[ $value -eq 0 ]];then
					flag1=0
			
				if [ $setline -eq 0 ];then
					sed -i "1 d" /etc/security/pwquality.conf
					if [ `sed -i "1 a dictcheck = 1" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::dictcheck::dictcheck = $value" >>/var/log/security_reinforce.txt
					fi
				else
					sed -i "$line d" /etc/security/pwquality.conf
					if [ `sed -i "$setline a dictcheck = 1" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::dictcheck::dictcheck = $value" >>/var/log/security_reinforce.txt
					fi
				fi
			fi
		elif [ `cat  /etc/security/pwquality.conf|awk '{print $1, $2, $3}'|egrep "dictcheck\s+="|grep "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
			line=`cat -n /etc/security/pwquality.conf |awk '{print $2, $3, $4, $1}'|egrep "dictcheck\s+=" |grep  "^#" |tail -n 1|awk '{print $4}'`
			setline=$(($line - 1))
			if [ $setline -eq 0 ];then
				sed -i "1 d" /etc/security/pwquality.conf
				if [ `sed -i "1 a dictcheck = 1" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
					flag=0
				else
					echo -e "COMMAND::0030::::sed -i '/dictcheck/s/^#//' /etc/security/pwquality.conf" >>/var/log/security_reinforce.txt
				fi

			else
				sed -i "$line d" /etc/security/pwquality.conf
				if [ `sed -i "$setline a dictcheck = 1" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
					flag=0
				else
					echo -e "COMMAND::0030::::sed -i '/dictcheck/s/^#//' /etc/security/pwquality.conf" >>/var/log/security_reinforce.txt
				fi
			fi
			flag1=0
		else
			flag1=0
			if [ `echo "dictcheck = 1" >> /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
				flag=0
			else
				echo "ADD_CONFIG::/etc/security/pwquality.conf::dictcheck::dictcheck = 1" >>/var/log/security_reinforce.txt
			fi
				
		fi
	fi
	if [ $flag1 -eq 1 ];then
		echo -e "--,密码字典检查设置,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	elif [ $flag -eq 0 ];then
		echo -e "--,密码字典检查设置,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	elif [ $flag -eq 1 ];then
		echo -e "--,密码字典检查设置,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi
}

function Password_usercheck_enable(){

	declare -i flag=1
	declare -i flag1=1
	str=""
	echo "--系统密码包含用户检查配置"

	if [ ` test -e /etc/security/pwquality.conf;echo $?` -eq 0 ];then

		if [ `cat -n /etc/security/pwquality.conf |grep -w "usercheck" |awk '{print $2, $3, $1}'|egrep "usercheck\s+="|grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
			line=`cat -n /etc/security/pwquality.conf |grep -w "usercheck"|awk '{print $2,$3, $1}'|egrep "usercheck\s+=" |grep -v "^#" |tail -n 1|awk '{print $3}'`
			value=`cat -n /etc/security/pwquality.conf |grep -w "usercheck"|awk '{print $2,$3,$4, $1}'|egrep "usercheck\s+=" |grep -v "^#" |tail -n 1|awk -F '=' '{print $2}'|awk '{print $1}'`
			setline=$(($line - 1))
				
			if [[ $value -eq 0 ]];then
					flag1=0
			
				if [ $setline -eq 0 ];then
					sed -i "1 d" /etc/security/pwquality.conf
					if [ `sed -i "1 a usercheck = 1" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::usercheck::usercheck = $value" >>/var/log/security_reinforce.txt
					fi
				else
					sed -i "$line d" /etc/security/pwquality.conf
					if [ `sed -i "$setline a usercheck = 1" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/security/pwquality.conf::usercheck::usercheck = $value" >>/var/log/security_reinforce.txt
					fi
				fi
			fi
		elif [ `cat  /etc/security/pwquality.conf|awk '{print $1, $2, $3}'|egrep "usercheck\s+="|grep "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
			line=`cat -n /etc/security/pwquality.conf |awk '{print $2, $3, $4, $1}'|egrep "usercheck\s+=" |grep "^#" |tail -n 1|awk '{print $4}'`
			setline=$(($line - 1))
			if [ $setline -eq 0 ];then
				sed -i "1 d" /etc/security/pwquality.conf
				if [ `sed -i "1 a usercheck = 1" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
					flag=0
				else
					echo -e "COMMAND::0031::::sed -i '/usercheck/s/^#//' /etc/security/pwquality.conf" >>/var/log/security_reinforce.txt
				fi

			else
				sed -i "$line d" /etc/security/pwquality.conf
				if [ `sed -i "$setline a usercheck = 1" /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
					flag=0
				else
					echo -e "COMMAND::0031::::sed -i '/usercheck/s/^#//' /etc/security/pwquality.conf" >>/var/log/security_reinforce.txt
				fi
			fi
			flag1=0
		else
			flag1=0
			if [ `echo "usercheck = 1" >> /etc/security/pwquality.conf 2>/dev/null;echo $?` -ne 0 ];then
				flag=0
			else
				echo "ADD_CONFIG::/etc/security/pwquality.conf::usercheck::usercheck = 1" >>/var/log/security_reinforce.txt
			fi
				
		fi
	fi
	if [ $flag1 -eq 1 ];then
		echo -e "--,密码包含用户检查设置,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	elif [ $flag -eq 0 ];then
		echo -e "--,密码包含用户检查设置,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	elif [ $flag -eq 1 ];then
		echo -e "--,密码包含用户检查设置,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
	fi
}


##########################################################################################
#口令生命周期加固
##########################################################################################
function Maximum_password_days(){

	declare -i flag=1
	declare -i flag1=1
	
	echo "--系统密码生命周期加固"
	echo "--系统密码生命周期加固" >> /var/log/ctgb_reinforce.log
	maxdays=$1
	if [ -z "$maxdays" ];then
		echo -e "--,用户密码最大有效期配置,\033[31m [没有输入密码最大有效期]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		flag1=2
		flag=2
	fi
	#for user in `cat /etc/passwd|awk -F ':' '{if(($3 == 0 || $3 >= 1000 || $1=="secadm"||$1=="auditadm") && $1 != "nobody") print $1}'`
	for user in `cat /etc/passwd|awk -F ':' '{if(($3 >= 1000 || $1=="secadm"||$1=="auditadm") && $1 != "nobody") print $1}'`
	do
		if [ `cat /etc/shadow |grep $user|awk -v str="$user" -v days=$maxdays -F ':' '{if($1=str && $5 > days) print $1}'|grep -v "#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
			value=$(cat /etc/shadow |grep $user|awk -v str="$user" -F ':' '{if($1=str) print $5}')
			flag1=0
			if [ `chage -M $maxdays $user 2>/dev/null 1>/dev/null;echo $?` -ne 0 ];then
				flag=0
			else
				echo "COMMAND1::0003::$user::chage -M $value $user" >>/var/log/security_reinforce.txt
			fi
		fi
	done
	
	if [ `cat /etc/login.defs |grep "PASS_MAX_DAYS"|awk '{print $1,$2}'| grep -v "^#" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
	
		line=`cat -n /etc/login.defs |grep "PASS_MAX_DAYS"|awk '{print $2,$1}'|grep -v "^#"|grep "PASS_MAX_DAYS"|tail -n 1|awk  '{print $2}'`
		value=`cat /etc/login.defs |grep "PASS_MAX_DAYS"|awk '{print $1,$2}'|grep -v "^#"|grep "PASS_MAX_DAYS"|tail -n 1|awk  '{print $2}'`
		setline=$(($line - 1))
		if [ $value -gt $maxdays ];then

				flag1=0
				if [ $setline -eq 0 ];then
					sed -i "1 d" /etc/login.defs
					if [ `sed -i "1 a PASS_MAX_DAYS        $maxdays" /etc/login.defs 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/login.defs::PASS_MAX_DAYS::PASS_MAX_DAYS  $value" >>/var/log/security_reinforce.txt
					fi
				else
					sed -i "$line d" /etc/login.defs
					if [ `sed -i "$setline a PASS_MAX_DAYS        $maxdays" /etc/login.defs 2>/dev/null;echo $?` -ne 0 ];then
						flag=0
					else
						echo "MODIFY_CONFIG::/etc/login.defs::PASS_MAX_DAYS::PASS_MAX_DAYS  $value" >>/var/log/security_reinforce.txt
					fi
				fi
		fi
	else
		if [ `echo "PASS_MAX_DAYS        $maxdays" >> /etc/login.defs 2>/dev/null;echo $?` -ne 0 ];then
			flag=0
		else
			echo "ADD_CONFIG::/etc/login.defs::PASS_MAX_DAYS::PASS_MAX_DAYS  $maxdays" >>/var/log/security_reinforce.txt
		fi
		flag1=0
	fi

	if [ $flag1 -eq 1 ];then
		echo -e "--,用户密码最大有效期设置,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,用户密码最大有效期设置,无需加固"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >> /var/log/ctgb_reinforce.log
	elif [ $flag -eq 0 ];then
		echo -e "--,用户密码最大有效期设置,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,用户密码最大有效期设置,失败"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >> /var/log/ctgb_reinforce.log
	else
		echo -e "--,用户密码最大有效期设置,\033[32m [成功]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,用户密码最大有效期设置,成功"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >> /var/log/ctgb_reinforce.log
	fi
}

##########################################################################################
#用户会话超时加固
##########################################################################################
function Session_timeout(){

	declare -i flag=1
	declare -i flag1=1
	echo "--用户会话超时加固"
	echo "--用户会话超时加固" >>/var/log/ctgb_reinforce.log
	timeout=$1
	if [ -z "$timeout" ];then
		echo -e "--,系统密码最小长度配置,\033[31m [没有输入最小长度]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		flag1=2
		flag=2
	fi

	if [ `cat /tmp/reinforce_status 2>/dev/null|grep "TMOUT=" 1>/dev/null 2>/dev/null;echo $?` -eq 0 ];then
		flag1=3
	else
		if [ `cat -n /etc/bash.bashrc|grep "TMOUT="|awk '{print $2,$0}'|grep -v "^#"|grep "TMOUT=" 2>/dev/null 1>/dev/null;echo $?` -eq 0 ];then	
			line=`cat -n /etc/bash.bashrc|grep "TMOUT="|awk '{print $2,$0}'|grep -v "^#"|grep "TMOUT="|tail -n 1|awk  '{print $2}'`
			value=`cat -n /etc/bash.bashrc|grep "TMOUT="|awk '{print $2 $3,$1}'|grep -v "^#"|grep "TMOUT="|tail -n 1|awk -F '=' '{print $2}'|awk '{print $1}'`
			setline=$(($line - 1))
			if [ $value -gt $timeout -o $value -eq 0 ];then
			
					if [[ $setline -eq 0 ]];then
						sed -i "1 d" /etc/bash.bashrc
						if [ `sed -i "1 a export TMOUT=$timeout" /etc/bash.bashrc 2>/dev/null;echo $?` -ne 0 ];then
							flag=0
						else
							echo "MODIFY_CONFIG::/etc/bash.bashrc::TMOUT::TMOUT=$value" >>/var/log/security_reinforce.txt
							echo "TMOUT=1" >>/tmp/reinforce_status
						fi
					else
						sed -i "$line d" /etc/bash.bashrc
						if [ `sed -i "$setline a export  TMOUT=$timeout" /etc/bash.bashrc 2>/dev/null;echo $?` -ne 0 ];then
							flag=0
						else
							echo "MODIFY_CONFIG::/etc/bash.bashrc::TMOUT::TMOUT=$value" >>/var/log/security_reinforce.txt
							echo "TMOUT=1" >>/tmp/reinforce_status
						fi
					fi
					kysec_set -n exectl -v verified /etc/bash.bashrc
			else
				flag1=0
			fi
		else
			if [ `echo "export TMOUT=$timeout" >> /etc/bash.bashrc 2>/dev/null;echo $?` -ne 0 ];then
				flag=0
			else
				kysec_set -n exectl -v verified /etc/bash.bashrc
				echo "ADD_CONFIG::/etc/bash.bashrc::TMOUT::TMOUT=$timeout" >>/var/log/security_reinforce.txt
				echo "TMOUT=1" >>/tmp/reinforce_status
			fi
		fi
	fi

	if [ $flag1 -eq 0 ];then
		echo -e "--,设置会话超时时间,\033[32m [无需加固]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,设置会话超时时间,无需加固"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/ctgb_reinforce.log
	elif [ $flag1 -eq 3 ];then
		echo -e "--,设置会话超时时间,\033[32m [无需加固，但需重启系统生效]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,设置会话超时时间,无需加固，但需重启系统生效"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/ctgb_reinforce.log
	elif [ $flag -eq 0 ];then
		echo -e "--,设置会话超时时间,\033[31m [失败]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,设置会话超时时间,失败"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/ctgb_reinforce.log
	elif [ $flag -eq 1 ];then
		echo -e "--,设置会话超时时间,\033[32m [成功，需重启系统生效]\033[0m"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}'
		echo -e "--,设置会话超时时间,成功"| awk -F , '{printf "%-10s%-70s%-20s\n", $1, $2,$3}' >>/var/log/ctgb_reinforce.log
	fi
}


Passwd_character_class 3
Passwd_minlen_setting 8
Password_dictcheck_enable
Password_usercheck_enable
Maximum_password_days 90
Session_timeout  600
